/*
 * File:   KNA9pointC.c
 * Author: shima(JR1KNA)
 * Device: PIC12F629
 * Created on 2021/06/09, 14:00
 */

#include <xc.h>
//#include <stdlib.h>
#ifndef _XTAL_FREQ
 // Unless already defined assume 4MHz system frequency
 // This definition is required to calibrate __delay_us() and __delay_ms()
 #define _XTAL_FREQ 4000000
#endif

// CONFIG1
#pragma config FOSC = INTRCIO    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON      // Power-up Timer Enable (PWRT disabled)
#pragma config MCLRE = OFF     // MCLR Pin Function Select (MCLR/VPP pin function is digital input)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable (Brown-out Reset disabled)

void init(void)
{
    OPTION_REG = 0b11011111;    // TMR0CS:0 = Internal instruction cycle clock (FOSC/4)
    T1CON = 0b00110101;         //bit 5-4:11 = 1:8 Prescale Value, bit 2:1 = Do not synchronize external clock, bit 0:1 = Enables Timer1
    INTCON = 0b10001000;        //bit 7 GIE: Global Interrupt Enable, bit 6 PEIE: Peripheral Interrupt Enable, bit 3 GPIE: Port Change Interrupt Enable
    IOC = 0b00001000;           //IOC<5:0>: Interrupt-on-Change GPIO Control bits
    PIE1 = 0b00000000;          //bit 0 TMR1IE: TMR1 Overflow Interrupt Enable bit
    CMCON = 0b00000111;         //CM<2:0> = 111;Comparators Off
    TRISIO = 0b00001000;        // port directions: 1=input, 0=output
    GPIO = 0b00000100;          //GPIO<5:0>: General Purpose I/O pin
}


bit MOD;
void main(void)
{
	__delay_ms(1000);
    init();
   
    GP0 = 0;
    GP1 = 0;
    GP5 = 0;
    GP4 = 0;
    
    GP4 = 1;
    __delay_ms(10);
    GP0 = 1;
    GP2 = 0;
    __delay_ms(40);
    GP0 = 0;
    GP4 = 0;
    __delay_ms(750);
    
    GP1 = 1;
    __delay_ms(10);
    GP5 = 1;
    GP2 = 1;
    __delay_ms(40);
    GP5 = 0;
    GP1 = 0;
    __delay_ms(150);
    
    if(GP3){MOD = 1;}
    
    while(MOD){
        
    }
    while(!MOD){
        
    }
}
void interrupt isr(void)
{
   if(!GP3&&GP2) {
        GP4 = 1;
        __delay_ms(10);
        GP0 = 1;
        GP2 = 0;
        __delay_ms(40);
        GP0 = 0;
        GP4 = 0;
        __delay_ms(150);   
   }
   else if(!GP3&&!GP2){
        GP1 = 1;
        __delay_ms(10);
        GP5 = 1;
        GP2 = 1;
        __delay_ms(40);
        GP5 = 0;
        GP1 = 0;
        __delay_ms(150);
   }
    GPIF = 0;
}